# all files / bpmn-js/lib/features/modeling/cmd/ ResizeLaneHandler.js

86.05% Statements 37/43
63.16% Branches 24/38
100% Functions 6/6
86.05% Lines 37/43

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134

    1189×
    1189×

    1×

    1×

    41×
    41×
    41×

    41×
    36×

    5×

    1×

    36×

    36×

    36×

    36×
    49×

    1×
    5×

    5×
    5×

    5×

    5×

    5×
    5×

    5×
    60×

    60×
    30×

    60×

    5×

    5×
    5×
    5×

    5×

    5×

    5×

    5×

     import { is } from '../../../util/ModelUtil';

    import {
      getLanesRoot,
      computeLanesResize
    } from '../util/LaneUtil';

    import {
      eachElement
    } from 'diagram-js/lib/util/Elements';

    import {
      asTRBL
    } from 'diagram-js/lib/layout/LayoutUtil';

    import {
      substractTRBL
    } from 'diagram-js/lib/features/resize/ResizeUtil';

    /**
     * A handler that resizes a lane.
     *
     * @param {Modeling} modeling
     */
    export default function ResizeLaneHandler(modeling, spaceTool) {
      this._modeling = modeling;
      this._spaceTool = spaceTool;
    }

    ResizeLaneHandler.$inject = [
      'modeling',
      'spaceTool'
    ];

    ResizeLaneHandler.prototype.preExecute = function(context) {

      var shape = context.shape,
          newBounds = context.newBounds,
          balanced = context.balanced;

      if (balanced !== false) {
        this.resizeBalanced(shape, newBounds);
      } else {
        this.resizeSpace(shape, newBounds);
      }
    };

    /**
     * Resize balanced, adjusting next / previous lane sizes.
     *
     * @param {djs.model.Shape} shape
     * @param {Bounds} newBounds
     */
    ResizeLaneHandler.prototype.resizeBalanced = function(shape, newBounds) {

      var modeling = this._modeling;

      var resizeNeeded = computeLanesResize(shape, newBounds);

      // resize the lane
      modeling.resizeShape(shape, newBounds);

      // resize other lanes as needed
      resizeNeeded.forEach(function(r) {
        modeling.resizeShape(r.shape, r.newBounds);
      });
    };

    /**
     * Resize, making actual space and moving below / above elements.
     *
     * @param {djs.model.Shape} shape
     * @param {Bounds} newBounds
     */
    ResizeLaneHandler.prototype.resizeSpace = function(shape, newBounds) {
      var spaceTool = this._spaceTool;

      var shapeTrbl = asTRBL(shape),
          newTrbl = asTRBL(newBounds);

      var trblDiff = substractTRBL(newTrbl, shapeTrbl);

      var lanesRoot = getLanesRoot(shape);

      var allAffected = [],
          allLanes = [];

      eachElement(lanesRoot, function(element) {
        allAffected.push(element);

        if (is(element, 'bpmn:Lane') || is(element, 'bpmn:Participant')) {
          allLanes.push(element);
        }

        return element.children;
      });

      var change,
          spacePos,
          direction,
          offset,
          adjustments;

      Eif (trblDiff.bottom || trblDiff.top) {

        change = trblDiff.bottom || trblDiff.top;
        spacePos = shape.y + (trblDiff.bottom ? shape.height : 0) + (trblDiff.bottom ? -10 : 10);
        direction = trblDiff.bottom ? 's' : 'n';

        offset = trblDiff.top > 0 || trblDiff.bottom < 0 ? -change : change;

        adjustments = spaceTool.calculateAdjustments(allAffected, 'y', offset, spacePos);

        spaceTool.makeSpace(adjustments.movingShapes, adjustments.resizingShapes, { x: 0, y: change }, direction);
      }

      Iif (trblDiff.left || trblDiff.right) {

        change = trblDiff.right || trblDiff.left;
        spacePos = shape.x + (trblDiff.right ? shape.width : 0) + (trblDiff.right ? -10 : 100);
        direction = trblDiff.right ? 'e' : 'w';

        offset = trblDiff.left > 0 || trblDiff.right < 0 ? -change : change;

        adjustments = spaceTool.calculateAdjustments(allLanes, 'x', offset, spacePos);

        spaceTool.makeSpace(adjustments.movingShapes, adjustments.resizingShapes, { x: change, y: 0 }, direction);
      }
    };